import requests
import json
import time

authorization = 'Bearer bce-v3/ALTAK-MyGbNEA18oT3boS2nOga1/d8b5057f7842f59b2c64971d8d077fe724d0aed5'


def call_chat_api(app_id: str, conversation_id: str, user_input: str) -> str:
    url = "https://qianfan.baidubce.com/v2/app/conversation/runs"

    payload = json.dumps({
        "app_id": app_id,
        "conversation_id": conversation_id,
        "query": user_input,
        "stream": False
    }, ensure_ascii=False)

    headers = {
        'Authorization': authorization,
        'Content-Type': 'application/json'
    }

    start_time = time.time()
    response = requests.post(url, headers=headers, data=payload.encode('utf-8'), timeout=60)
    end_time = time.time()

    elapsed_time = end_time - start_time
    print(f"Elapsed time: {elapsed_time:.2f} seconds")
    answer = json.loads(response.text)["answer"]
    return answer.strip("\n```json")


def get_conversation_id(app_id: str) -> str:
    url = "https://qianfan.baidubce.com/v2/app/conversation"

    payload = json.dumps({
        "app_id": app_id
    }, ensure_ascii=False)

    headers = {
        'Authorization': authorization,
        'Content-Type': 'application/json'
    }

    response = requests.post(url, headers=headers, data=payload.encode('utf-8'), timeout=60)
    return json.loads(response.text)["conversation_id"]


if __name__ == "__main__":
    conversation_id = get_conversation_id("256fd853-60b0-4357-b11b-8114b4e90ae0")
    print(conversation_id)
    result = call_chat_api("256fd853-60b0-4357-b11b-8114b4e90ae0", conversation_id,
                            "反复咳嗽、咳痰伴低热2月余，加重伴夜间盗汗1周。")
    print(result)