import requests
import json

def chat(question):
    url = "https://qianfan.baidubce.com/v2/chat/completions"

    payload = json.dumps({
        "model": "deepseek-v3",
        "messages": [
            {
                "role": "user",
                "content": question
            }
        ]
    }, ensure_ascii=False)
    headers = {
        'Content-Type': 'application/json',
        'appid': '',
        'Authorization': 'Bearer bce-v3/ALTAK-4724E5sCJcdxRCBCilJoL/641317ddac7137060721e65e688876f6c772115d'
    }

    response = requests.request("POST", url, headers=headers, data=payload.encode("utf-8"))
    #response.text是个json，获取choices数组中第一个元素的message的content字段
    answer = json.loads(response.text)
    answer = answer["choices"][0]["message"]["content"]

    print(answer)
    #返回answer
    return answer



if __name__ == '__main__':
    print(chat('1985年今年几岁'))
